
function navCal()
{
	var s = "../?ae=Folder&t=IPF.Appointment";
	parent.location.href = s;

	return false;
}

function navMail()
{
	var s = "../?ae=Folder&t=IPF.Note";
	parent.location.href = s;

	return false;
}

function navTsks()
{
	if ((typeof(g_szTaskFolderID)!="undefined") && g_szTaskFolderID)
	{
		var s = "../?ae=Folder&t=IPF.Task&id=" + g_szTaskFolderID;
		parent.location.href = s;
	}

	return false;
}


function openCal(sCalItemId)
{
	var s = "../?ae=PreFormAction&a=Open&t=IPM.Appointment&id=" + sCalItemId;
	parent.location.href = s;

	return false;
}

function openTask(sTaskItemId)
{
	var s = "../?ae=Item&t=IPM.Task&id=" + sTaskItemId;
	parent.location.href = s;

	return false;
}

function GetXmlHttpRequest() {
	var oReq = null;

	try 
	{
		if((typeof(window.XMLHttpRequest) != "undefined") && window.XMLHttpRequest) 
		{
			//For Firefox, Safari, Opera
			oReq = new XMLHttpRequest();
		}
	}
	catch(e) 
	{
		oReq = null;
	}

	if (oReq == null) 
	{
		try 
		{
			if((typeof(window.ActiveXObject) != "undefined") && window.ActiveXObject) 
			{
				//For IE 5+
				oReq = new ActiveXObject("Microsoft.XMLHTTP");
			}
		}
		catch(e) 
		{
			oReq = null;
		}
	}

	return oReq;
}

function GetOneAndOnlyUserContextCookieValue()
{
	var szUserContextValue = null;
	var foundFirstUserContext = false;

	if(document.cookie)
	{
		var szSearchName = "USERCONTEXT";
		var szSearchName2 = "USERCONTEXT_";

		var arrCookie = document.cookie.split(';');
		var c, cname;

		for(var i=0;i<arrCookie.length;i++)
		{
			c = arrCookie[i];
			c = c.replace(/^\s*/i,"");
			c = c.replace(/^AMWEBJCT![^!=]+!/i,"");
			if(c.indexOf("=") != -1)
			{
				cname = c.substr(0, c.indexOf("="));

				//Is it a UserContext cookie?				
				var szUCValue = null;
				if ((szSearchName == cname.toUpperCase()) && (cname.length + 1 < c.length))
				{
					//UserContext=..
					szUCValue = c.substring(cname.length + 1 , c.length);
				}
				else
				if ((szSearchName2 == cname.toUpperCase().substr(0, szSearchName2.length)) && (cname.length + 1 < c.length))
				{
					//UserContext_..=..
					szUCValue = c.substring(cname.length + 1 , c.length);
				}

				//If this is the 2nd UserContext that we have found, return null
				if (szUCValue != null && szUCValue != "")
				{
					if (foundFirstUserContext)
						return null;
					else
					{
						szUserContextValue = szUCValue;
						foundFirstUserContext = true;
					}
				}
			}
		}
	}

	if (!foundFirstUserContext)
		return null;
	else
	{
		var n = szUserContextValue.indexOf("&");
		if (n != -1)
			szUserContextValue = szUserContextValue.substr(0, n);

		return szUserContextValue;
	}
}

function IsE2007SP3orLater()
{
	var bE2007SP3orLater = false;

	if (parent && typeof(parent.g_szOWABuild) != "undefined" && parent.g_szOWABuild != null)
	{
		var d1 = parent.g_szOWABuild.indexOf(".");
		var d2 = -1;
		if (d1 > 0) d2 = parent.g_szOWABuild.substr(d1 + 1).indexOf(".");
			
		if (d1 > 0 && d2 > 0)
		{
			var szB1 = parent.g_szOWABuild.substr(0, d1);
			var szB2 = parent.g_szOWABuild.substr(d1 + 1, d2);

			if (szB1 != "" && szB2 != "")
			{
				var b1 = parseInt(szB1);
				var b2 = parseInt(szB2);

				if (!isNaN(b1) && !isNaN(b2))
					bE2007SP3orLater = (b1 > 8) || ((b1 == 8) && (b2 >= 3));
			}
		}
	}

	return bE2007SP3orLater;
}

function GetCanaryValue()
{
	var szCanary = "";

	//First try to get canary value from hidcanary element
	var fr = null;
	if (parent)
	{
		if (typeof(parent.g_oFrm) != "undefined" && parent.g_oFrm != null)
			fr = parent.g_oFrm;
		else if (typeof(parent.document) != "undefined" && parent.document != null && typeof(parent.document.forms) != "undefined" && parent.document.forms != null)
			fr = parent.document.forms["frm"];
	}

	if (fr != null && fr["hidcanary"] != null && typeof(fr["hidcanary"].value) !="undefined")
		szCanary = fr["hidcanary"].value;

	//If we failed to obtain canary element, try to get it from UserContext cookie
	if (szCanary == null || szCanary == "")
		szCanary = GetOneAndOnlyUserContextCookieValue();

	return szCanary;
}


var g_oXmlHttp = null;

function onCompleteTaskClick(chkBox, sTaskItemID)
{
	if (chkBox)
	{
		var szCanaryElement = "";
		if (IsE2007SP3orLater())
		{
			//For E2007 SP3+ we need to add the canary value to the request. If it is not available return without making a request.
			var szCanary = GetCanaryValue();
			if (szCanary == null || szCanary == "")
				return;
			else
				szCanaryElement = "<canary>" + szCanary + "</canary>";
		}

		var sURL = "../ev.owa?oeh=1&ns=TskListView&ev=MarkComplete";

		var sPOSTData = "<params>" + szCanaryElement + "<Itms><item>" + sTaskItemID + "</item></Itms>";

		if (!chkBox.checked)
			sPOSTData += "<mkIncmp>1</mkIncmp>";

		sPOSTData += "</params>";

		g_oXmlHttp = GetXmlHttpRequest();
		if (g_oXmlHttp)
		{
			g_oXmlHttp.open("POST", sURL , true);
			//g_oXmlHttp.setRequestHeader("X-UserActivity","0");
			g_oXmlHttp.onreadystatechange = completeTaskRequestCallback;
			g_oXmlHttp.send(sPOSTData);
		}
	}
	return false;
}

function completeTaskRequestCallback()
{
	try
	{
		if (g_oXmlHttp.readyState != 4) return false;
	
		if ((g_oXmlHttp.status < 200)||(g_oXmlHttp.status > 299)) 
		{
			if ((typeof(g_szErrMsgTaskUpdate)!="undefined") && g_szErrMsgTaskUpdate)
				alert(g_szErrMsgTaskUpdate);
		}
		else 
		{
			//alert("success");
		}
	}
	catch(e)
	{
	}

	refreshOWAToday();
	return true;
}

function refreshOWAToday()
{
	var frm = document.getElementById("mainfrm");	
	if (frm)
	{
		//refresh the page
		frm.submit();
	}
}

function onFolderClick(sFolderID, nFolderType)
{
	var s = "../?ae=Folder";

	switch(nFolderType)
	{
		case 0: //Calendar
			s += "&t=IPF.Appointment";
			break;

		case 1: //Contacts
			s += "&t=IPF.Contact";
			break;

		case 2: //Mail Folder 
			s += "&t=IPF.Note";
			break;

		case 3: //Search
			return;

		case 4: //Tasks
			s += "&t=IPF.Task";
			break;

		default:
			return;
	}

	s += "&id=" + encodeURIComponent(sFolderID);
	parent.location.href = s;

	return false;
}

function window_onload()
{
	//Display
	if(0==g_nRetCode)	//GET/POST succeeded
	{	
		if (parent && (typeof(parent.g_OWATodaySubFrame)!="undefined"))	
			parent.g_OWATodaySubFrame = this;
		return;
	}
	else			//Failed
	{
		if ((typeof(g_szErrMsg) != "undefined") && g_szErrMsg && (g_szErrMsg != ""))
			alert(g_szErrMsg);

		return;
	}
}

