
function navCal()
{
	var oPar = window.parent;

	while (oPar)
	{
		if ((typeof(oPar.navCal)=="undefined") || !oPar.navCal)
		{
			if ((typeof(oPar.parent)!="undefined") && oPar.parent && (oPar.parent!=oPar) && (oPar.parent!=window))
				oPar = oPar.parent;
			else
				break;
		}
		else
		{
			oPar.navCal();
			break;
		}
	}
	return false;
}

function navTsks()
{
	var oPar = window.parent;

	while (oPar)
	{
		if ((typeof(oPar.navTsks)=="undefined") || !oPar.navTsks)
		{
			if ((typeof(oPar.parent)!="undefined") && oPar.parent && (oPar.parent!=oPar) && (oPar.parent!=window))
				oPar = oPar.parent;
			else
				break;
		}
		else
		{
			oPar.navTsks();
			break;
		}
	}
	return false;
}

function navMail()
{
	var oPar = window.parent;

	while (oPar)
	{
		if ((typeof(oPar.navMail)=="undefined") || !oPar.navMail)
		{
			if ((typeof(oPar.parent)!="undefined") && oPar.parent && (oPar.parent!=oPar) && (oPar.parent!=window))
				oPar = oPar.parent;
			else
				break;
		}
		else
		{
			if ((typeof(oPar.g_rgsLFids)!="undefined") && (oPar.g_rgsLFids[oPar.NM_MAIL]=="mwowatoday")) {
			   oPar.g_rgsLFids[oPar.NM_MAIL] = (typeof(oPar.a_sInbx)!="undefined") ? oPar.a_sInbx : null;
			}

			oPar.navMail();
			break;
		}
	}
	return false;
}

function openCal(sCalItemId)
{
	if (parent && (typeof(parent.g_strBase)!="undefined") && (parent.g_strBase!=null))
	{
		window.open(
			parent.g_strBase + "?ae=PreFormAction&a=Open&t=IPM.Appointment&id=" + sCalItemId,
			"",
			"width=700,height=500,toolbar=0,location=0,menubar=0,resizable=1" );
	}
	return false;
}

function openTask(sTaskItemId)
{
	if (parent && (typeof(parent.g_strBase)!="undefined") && (parent.g_strBase!=null))
	{
		window.open(
			parent.g_strBase + "?ae=PreFormAction&a=Open&t=IPM.Task&id=" + sTaskItemId,
			"",
			"width=700,height=500,toolbar=0,location=0,menubar=0,resizable=1" );
	}
	return false;
}

function GetXmlHttpRequest() {
	var oReq = null;

	try 
	{
		if((typeof(window.XMLHttpRequest) != "undefined") && window.XMLHttpRequest) 
		{
			//For Firefox, Safari, Opera
			oReq = new XMLHttpRequest();
		}
	}
	catch(e) 
	{
		oReq = null;
	}

	if (oReq == null) 
	{
		try 
		{
			if((typeof(window.ActiveXObject) != "undefined") && window.ActiveXObject) 
			{
				//For IE 5+
				oReq = new ActiveXObject("Microsoft.XMLHTTP");
			}
		}
		catch(e) 
		{
			oReq = null;
		}
	}

	return oReq;
}

function IsE2007SP3orLater()
{
	var bE2007SP3orLater = false;

	if (parent && typeof(parent.g_szOWABuild) != "undefined" && parent.g_szOWABuild != null)
	{
		var d1 = parent.g_szOWABuild.indexOf(".");
		var d2 = -1;
		if (d1 > 0) d2 = parent.g_szOWABuild.substr(d1 + 1).indexOf(".");
			
		if (d1 > 0 && d2 > 0)
		{
			var szB1 = parent.g_szOWABuild.substr(0, d1);
			var szB2 = parent.g_szOWABuild.substr(d1 + 1, d2);

			if (szB1 != "" && szB2 != "")
			{
				var b1 = parseInt(szB1);
				var b2 = parseInt(szB2);

				if (!isNaN(b1) && !isNaN(b2))
					bE2007SP3orLater = (b1 > 8) || ((b1 == 8) && (b2 >= 3));
			}
		}
	}

	return bE2007SP3orLater;
}


var g_oXmlHttp = null;

function onCompleteTaskClick(chkBox, sTaskItemID)
{
	if (chkBox && parent && (typeof(parent.g_strBase)!="undefined") && (parent.g_strBase!=null))
	{
		var szCanaryElement = "";
		if (IsE2007SP3orLater())
		{			
			var szCanary = null;

			//Get UserContext cookie value
			if (typeof(parent.rtrvUCCk) != "undefined" && parent.rtrvUCCk != null)
				szCanary = parent.rtrvUCCk();

			//If we couldn't obtain UserContext cookie value return without making a request
			if (szCanary == null || szCanary == "")
				return;
			else
				szCanaryElement = "<canary>" + szCanary + "</canary>";
		}

		var sURL = parent.g_strBase + "ev.owa?oeh=1&ns=TskListView&ev=MarkComplete";

		var sPOSTData = "<params>" + szCanaryElement + "<Itms><item>" + sTaskItemID + "</item></Itms>";

		if (!chkBox.checked)
			sPOSTData += "<mkIncmp>1</mkIncmp>";

		sPOSTData += "</params>";

		g_oXmlHttp = GetXmlHttpRequest();
		if (g_oXmlHttp)
		{
			g_oXmlHttp.open("POST", sURL , true);
			//g_oXmlHttp.setRequestHeader("X-UserActivity","0");
			g_oXmlHttp.onreadystatechange = completeTaskRequestCallback;
			g_oXmlHttp.send(sPOSTData);
		}
	}
	return false;
}

function completeTaskRequestCallback()
{
	try
	{
		if (g_oXmlHttp.readyState != 4) return false;
	
		if ((g_oXmlHttp.status < 200)||(g_oXmlHttp.status > 299)) 
		{
			if ((typeof(g_szErrMsgTaskUpdate)!="undefined") && g_szErrMsgTaskUpdate)
				alert(g_szErrMsgTaskUpdate);
		}
		else 
		{
			//alert("success");
		}
	}
	catch(e)
	{
	}

	refreshOWAToday();
	return true;
}

function refreshOWAToday()
{
	var frm = document.getElementById("mainfrm");	
	if (frm)
	{
		//refresh the page
		frm.submit();
	}
}


function onFolderClick(sFolderID, nFolderType)
{
	var oPar = window.parent;
	while (oPar)
	{
		if ((typeof(oPar.nav)=="undefined") || !oPar.nav ||
		    (typeof(oPar.nvCtx)=="undefined") || !oPar.nvCtx)
		{
			if ((typeof(oPar.parent)!="undefined") && oPar.parent && (oPar.parent!=oPar) && (oPar.parent!=window))
				oPar = oPar.parent;
			else
			{
				return;
				break;
			}
		}
		else
		{
			break;
		}
	}

	var oN=oPar.nvCtx();

	switch(nFolderType)
	{
		case 0: //Calendar
			oN.fP=1;
			oN.fR=0;
			oN.cb=oPar.onNavCal;
			oPar.nav(oPar.NM_CAL,oPar.T_CAL,sFolderID,oN);
			break;

		case 1: //Contacts
			oN.fP=1;
			oN.fR=0;
			oN.cb=oPar.onNavCnt;
			oN.sFltr=null;
			oPar.nav(oPar.NM_CTS,oPar.T_CON,sFolderID,oN);
			break;

		case 2: //Mail Folder 
			oN.fP=1;
			oN.fR=0;
			oN.cb=oPar.onNavMail;
			oPar.nav(oPar.NM_MAIL,oPar.T_MSG,sFolderID,oN);
			break;

		case 3: //Search
			break;

		case 4: //Tasks
			oN.fP=1;
			oN.fR=0;
			oN.cb=oPar.onNavTsk;
			oPar.nav(oPar.NM_TSK,oPar.T_TSK,sFolderID,oN);
			break;
	}
	return false;
}

function window_onload()
{
	//Display
	if(0==g_nRetCode)	//GET/POST succeeded
	{
		if (parent && (typeof(parent.g_OWATodaySubFrame)!="undefined"))	
			parent.g_OWATodaySubFrame = this;
		return;
	}
	else			//Failed
	{
		if ((typeof(g_szErrMsg) != "undefined") && g_szErrMsg && (g_szErrMsg != ""))
			alert(g_szErrMsg);

		return;
	}
}

